## <b>RTC_Alarm_Init Example Description</b>

Configuration of the RTC LL API to configure and generate an alarm using the RTC peripheral. The peripheral
initialization uses the LL initialization function.

In this example, after start-up, SYSCLK is configured to the max frequency using HSI as clock source.

The RTC peripheral configuration is ensured by the Configure_RTC() function
(configure of the needed RTC resources according to the used hardware CLOCK,
PWR, RTC clock source and BackUp). You may update this function to change RTC configuration.

#### <b>Notes</b>

 1. LSI oscillator clock is used as RTC clock source by default.
    The user can use also LSE as RTC clock source.
    - The user uncomment the adequate line on the main.c file.

      @code

        #define RTC_CLOCK_SOURCE_LSI

        /* #define RTC_CLOCK_SOURCE_LSE */

      @endcode

    - Open the ioc file with STM32CubeMX and select :

      LSE as "Crystal/Ceramic Resonator" in RCC configuration.

      LSE as RTC clock source in Clock configuration.

    - Generate code

    LSI oscillator clock is delivered by a 32 kHz RC.

    LSE (when available on board) is delivered by a 32.768 kHz crystal.

Configure_RTC_Alarm function is then called to initialize the time, date and alarm.

In this example, the Time is set to 11:59:55 PM and the Alarm must be generated after
30 seconds on 12:00:25 AM.

LED1 is turned ON when the RTC Alarm is generated correctly.

The current time and date are updated and displayed on the debugger in aShowTime
and aShowDate variables (watch or live watch).

In case of error, LED1 is toggling.

### <b>Keywords</b>

System, RTC, Alarm, wakeup timer, Backup domain, Counter, LSE, LSI

### <b>Directory contents</b>

  - RTC/RTC_Alarm_Init/Inc/stm32c0xx_it.h     Interrupt handlers header file
  - RTC/RTC_Alarm_Init/Inc/main.h             Header for main.c module
  - RTC/RTC_Alarm_Init/Inc/stm32_assert.h     Template file to include assert_failed function
  - RTC/RTC_Alarm_Init/Src/stm32c0xx_it.c     Interrupt handlers
  - RTC/RTC_Alarm_Init/Src/main.c             Main program
  - RTC/RTC_Alarm_Init/Src/system_stm32c0xx.c STM32C0xx system source file

### <b>Hardware and Software environment</b>

  - This example runs on STM32C031C6Tx devices.

  - This example has been tested with STM32C0316-DISCO board and can be
    easily tailored to any other supported device and development board.

### <b>How to use it ?</b>

In order to make the program work, you must do the following :

 - Open your preferred toolchain
 - Rebuild all files and load your image into target memory
 - Run the example

